<xsl:stylesheet version = "1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:rc="http://www.ibm.com/xmlns/prod/SystemsManagement/v2.0/ResourceCollection" >

<xsl:template match="rc:ResourceCollection">
  <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US" lang="en-US">
    <head profile="http://www.w3.org/2000/08/w3c-synd/#">
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
      <title>RCF Inventory</title>
    </head>

    <body>
      <h1 align="center">RCF Inventory </h1>
      <h2> Quick Links </h2>
      <a href="#Server Information">Server Information</a> 
      <a href="#Operating System Information">Operating System Information</a> 
      <a href="#Software Installations">Software Installations</a>
      <a href="#Software Component Installation">Software Component Installation</a> 
      <a href="#Temporary Fix Installations">Temporary Fix Installations</a>
      
      <a name="Server Information"><h2> Server Information </h2></a>
      <table border="1">
      <xsl:for-each select="//*[@resourceType='Server']/rc:Property">
      <tr>
      <td><xsl:value-of select="@name" /></td>
      <td><xsl:value-of select="rc:Value" /></td>
      </tr>
      </xsl:for-each>
      
      </table>
      
      <a name="Operating System Information"><h2> Operating System Information </h2></a>
      <table border="1">
      <xsl:for-each select="//*[@resourceType='OperatingSystem']/rc:Property">
      <tr>
      <td><xsl:value-of select="@name" /></td>
      <td><xsl:value-of select="rc:Value" /></td>
      </tr>
      </xsl:for-each>
      </table>
      
      <a name="Software Installations"><h2> Software Installations </h2></a>
      <table border="1">
      <xsl:for-each select="//rc:ResourceInstance[@resourceType='SoftwareInstallation']">
      <xsl:for-each select="rc:Property">
      <tr>
      <td><xsl:value-of select="@name" /></td>
      <td><xsl:value-of select="rc:Value" /></td>
      </tr>      
      </xsl:for-each>
      <tr>
      <td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
      <td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
      </tr>  
      </xsl:for-each>
      </table>
      
      <a name="Software Component Installation"><h2> Software Component Installation </h2></a>
      <table border="1">
      <xsl:for-each select="//rc:ResourceInstance[@resourceType='SoftwareComponentInstallation']">
      <xsl:for-each select="rc:Property">
      <tr>
      <td><xsl:value-of select="@name" /></td>
      <td><xsl:value-of select="rc:Value" /></td>
      </tr>      
      </xsl:for-each>
      <tr>
      <td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
      <td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
      </tr>  
      </xsl:for-each>
      </table>
      
      <a name="Temporary Fix Installations"><h2> Temporary Fix Installations </h2></a>
      <table border="1">
      <xsl:for-each select="//rc:ResourceInstance[@resourceType='TemporaryFixInstallation']">
      <xsl:for-each select="rc:Property">
      <tr>
      <td><xsl:value-of select="@name" /></td>
      <td><xsl:value-of select="rc:Value" /></td>
      </tr>      
      </xsl:for-each>
      <tr>
      <td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
      <td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
      </tr>  
      </xsl:for-each>
      </table>
      
      
    </body>
  </html>
</xsl:template>

     

</xsl:stylesheet>